
/* (stolen from fifi, http://puska.keltti.jyu.fi/fifi) */

/* hash.c - hash table operations stuff */

/* $Id: hash.c,v 1.2 2002/08/18 09:52:46 engerim Exp $ */

/*
 * $Log: hash.c,v $
 * Revision 1.2  2002/08/18 09:52:46  engerim
 * Added files of jv
 *
 * Revision 1.1  1999/05/11 19:15:19  steven
 * added hash.[ch] and hook.[ch]
 * finally this thing is back online :p
 *
 */

#include "hash.h"

/* add_to_hash - adds a List compatible structure into the hash
 * parameters:
 * hash - hash table
 * size - the size to allocate (for the structure)
 * name - string identifier of the structure
 * id - numeric identifier
 * hash_func() - hashing function
 * return value :
 *   pointer to newly added hash-entry , or NULL on failure 
 */

List *add_to_hash(Hash hash, size_t size, char *name, int id,
		  int hash_func(char *name, int id))
{
    return add_to_list(hash + hash_func(name, id), NULL, size, name, id);
}

/* remove_from_hash - remove a List compatible structure from the hash
 * parameters:
 * hash - hash table
 * p - pointer to List-structure to remove
 * hash_func() - hashing function
 * return value: none
 */

void remove_from_hash(Hash hash, List * p, int hash_func(char *name, int id))
{
    remove_from_list(hash + hash_func(p->name, p->id), NULL, p);
}


List *find_in_hash_by_name(Hash hash, char *name, int id,
			   int cmp_func(const char *a, const char *b),
			   int hash_func(char *name, int id))
{
    return find_in_list_by_name(*(hash + hash_func(name, id)), name, cmp_func);
}


List *find_in_hash_by_id(Hash hash, char *name, int id,
			 int cmp_func(int a, int b),
			 int hash_func(char *name, int id))
{
    return find_in_list_by_id(*(hash + hash_func(name, id)), id, cmp_func);
}
